extpython
=========

Isolated python .deb builder

Extpython is a collection of tools for building installable packages containing various versions of Python. The
installations are isolated from the operating system's python such that modules may be added, removed, or upgraded
without risk of breaking. The builds are executed in Docker.

*Example invocation:*

```
./images.sh                      # pulls / creates base images with dependencies
./build.sh trusty-3.9.5.sh       # build using the recipe in the named script file
```

The vars file - `trusty-3.9.5.sh` above - contains information about what python version will be built. See
`src/bionic-3.9.5.sh` for an annotated example.


Version support matrix
----------------------

|        | 2.7    | 3.6              | 3.7   | 3.8                  | 3.9    | 3.10    | 3.11   |
|--------|--------|------------------|-------|----------------------|--------|---------|--------|
| 14.04  |        | 3.6.7<br />3.6.8 |       |                      | 3.9.5* | 3.10.0* |        |
| 16.04  |        | 3.6.7            | 3.7.3 |                      | 3.9.5  | 3.10.0* |        |
| 18.04  | 2.7.16 | 3.6.7            | 3.7.3 | 3.8.0a4<br />3.8.0b1 | 3.9.5  | 3.10.0  | 3.11.5 |
| 19.04  |        |                  | 3.7.3 |                      |        |         |        |
| 20.04  |        |                  |       |                      | 3.9.5  | 3.10.0  | 3.11.5 |
| 22.04  |        |                  |       |                      |        |         | 3.11.5 |

\* with provided extpython-openssl packages - see below


Openssl
-------

Some versions of Python require a version of openssl that is newer than what ships on many of these host OSes. To
satisfy this requirement, extpython also builds an Openssl package that installs in a similar isolated manner.

See `./ssl/` for details.


TODO
----

* Parameter for pre-loaded pip modules



Uploading
---------

`curl -v 'http://artifact.scc.net.davepedu.com/addpkg?provider=tar&reponame=cpython&version=3.10.0' -F 'f=@cpython-3.10.0.tar.gz'`

`rpcli -s http://artifact.scc.net.davepedu.com upload -y apt -f builds/3.10.0/trusty/extpython-python3.10_3.10.0_amd64.deb -r extpython -p extpython-python3.10 -i 3.10.0 -a dist=trusty`



Testing
-------

Install extpython in a temporary container an run it.

`docker run -it --rm ubuntu:bionic bash`

```
sed -i -E 's/(archive|security).ubuntu.com/aptmirror/' /etc/apt/sources.list && \
sed -i -E 's/^deb-src/# deb-src/' /etc/apt/sources.list && \
apt-get update && \
DEBIAN_FRONTEND=noninteractive apt-get install -y wget gnupg && \
. /etc/lsb-release && \
wget -q -O- http://artifact.scc.net.davepedu.com/repo/apt/extpython/dists/${DISTRIB_CODENAME}/install | bash -x /dev/stdin && \
apt-get install -y extpython-python3.10
```
