#!/bin/bash -eux

export EXTPYTHON_DIST=xenial
export PYTHON_RELEASE=3.10.0
export PYTHON_MAJOR=3.10
export PYTHON_TARBALL="http://artifact.scc.net.davepedu.com/repo/tar/cpython/cpython/cpython-${PYTHON_RELEASE}.tar.gz"
export CPYTHON_DEPS="libssl-dev zlib1g-dev libncurses5-dev libncursesw5-dev \
    libreadline-dev libsqlite3-dev libgdbm-dev libdb5.3-dev libbz2-dev libexpat1-dev liblzma-dev tk-dev libffi-dev uuid-dev"

# Optional script to run in the build container early in the build process
export INSIDE_SCRIPT='#!/bin/bash -eux
    wget -q -O- http://artifact.scc.net.davepedu.com/repo/apt/extpython/dists/xenial/install | bash -x /dev/stdin
    apt-get update -qq
    apt-get install -y extpython-openssl-1-1
'

# Extra args for python's configure script
export EXTRA_PY_CONFIGURE_FLAGS="--with-openssl=/opt/extpython/ssl/1.1.1l --enable-optimizations"

# Name of the rules makefile used to build the deb package
export RULESFILE=rules.openssl-1.1.1l

# Other arbitrary environment variables
# xenial's native openssl is too old, so we ship a newer version. Embed the library path
export LDFLAGS=-Wl,-rpath=/opt/extpython/ssl/1.1.1l/lib
